/*
  Crystal Design Component Demo Application 2:

  Copyright (c) 1998, SupraSoft Ltd

  Purpose of this program is to demonstrate
  - Use of parameter fields (TCDCParameterFieldInfo)
  - Use of selection formula (SetSelectionFormula)
  - Use of formula (SetFormula)
*/

//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "demo2.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "Crystdsg"
#pragma resource "*.dfm"
TForm2 *Form2;
//---------------------------------------------------------------------------
__fastcall TForm2::TForm2(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm2::FormCreate(TObject *Sender)
{
  AnsiString exePath;
  exePath = ExtractFilePath(Application->ExeName);

  // Report file AND database file are in the same place
  // with the exectuable file.
  CrystalDesign1->ReportLocation = exePath;
  CrystalDesign1->CommonTableLocations = exePath;
}
//---------------------------------------------------------------------------

void __fastcall TForm2::Button1Click(TObject *Sender)
{
  AnsiString text;
  TCDCParameterFieldInfo *cdcField;

  CrystalDesign1->Active = FALSE;

  // Set the value of a parameter field. GetNthCDCParameterField
  // creates and returns a field object. However, caller is
  // responsible to delete the returned object when caller does
  // not need the object anymore.
  cdcField = CrystalDesign1->GetNthCDCParameterField(0);
  if(cdcField != NULL)
  {
     // Set current value of a parameter field programmatically
     // using string type. There are also ex. AsInteger, AsDate
     // and AsDouble properties. When the component is activated,
     // the standard parameter field input dialogbox is NOT shown.
     cdcField->CurrentValue->AsString = ComboBox1->Text;

     // Send parameter field values to a report and delete the object
     cdcField->SetField();
     delete cdcField;
  }


  // Set selection formula value based on a month filter
  text = "";
  if(ComboBox2->ItemIndex > 0)
     text = "Month({customer.ContactDat}) = " + IntToStr(ComboBox2->ItemIndex);
  CrystalDesign1->SetSelectionFormula(text);


  // Set a content of a "Caption" formula in a report to show month
  // filter value. Please note how the double quote is added to the string.
  text = "{?City} + \" Office " + ComboBox2->Text + "\"";
  CrystalDesign1->SetFormula("Caption", text);


  // Re-activate the component
  CrystalDesign1->Active = TRUE;
}
//---------------------------------------------------------------------------

void __fastcall TForm2::CrystalDesign1Error(TObject *Sender)
{
  // Set possible last error text to form caption
  Caption = CrystalDesign1->LastErrorText;
}
//---------------------------------------------------------------------------

void __fastcall TForm2::Button2Click(TObject *Sender)
{
  // Toggle between three standard zoom factors
  CrystalDesign1->NextPrintWindowMagnification();
}
//---------------------------------------------------------------------------

