/*
  Crystal Design Component Demo Application 3:

  Copyright (c) 1998, SupraSoft Ltd

  Purpose of this program is to demonstrate
  - How to use Delphi's TQuery, TTable and TStoredProc components
    as a datasource in a report.
  - How to force dataset field types to a different type using
    SetDatasetFieldType-method.

  In this program you can enter standard SQL-query to a Memo1-component.
  The result of Query1-component is shown in a DBGrid and in a report.
*/

//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "demo3.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "Crystdsg"
#pragma resource "*.dfm"
TForm3 *Form3;
//---------------------------------------------------------------------------
__fastcall TForm3::TForm3(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm3::FormCreate(TObject *Sender)
{
  AnsiString exePath;

  // Report file is in the same directory with the executable
  exePath = ExtractFilePath(Application->ExeName);
  CrystalDesign1->ReportLocation = exePath;

  // Show the SQL query value in a memo field
  Memo1->Lines->Assign(Query1->SQL);

  // If database connection fails then please check the Params     }
  // property of Database1-component that it contains a valid path }
  // to the CUSTOMER.DBF file.                                     }
  Database1->Connected = FALSE;
  Database1->Params->Values["PATH"] = exePath;
  Database1->Connected = TRUE;
}
//---------------------------------------------------------------------------

void __fastcall TForm3::ActivateComponent()
{
  CrystalDesign1->Active = FALSE;

  // The first table (index 0) uses Query1 as a datasource
  CrystalDesign1->SetNthDataset(0, Query1);

  // When we use string type in a DATE field, TField.DisplayFormat
  // setting will be used also. If you comment out the
  // SetDatasetFieldType line then you'll see the difference.
  if(Query1->FindField("ContactDat") != NULL)
  {
     // Here we use safe dynamic cast to make sure that
     // the field returned from Query1 is type of TDateField.
     dynamic_cast<TDateField*>(Query1->FieldByName("ContactDat"))->DisplayFormat = "[mmm dd yyyy]";

     CrystalDesign1->SetDatasetFieldType (0, "ContactDat", ftString);
  }

  CrystalDesign1->Active = TRUE;
}

//---------------------------------------------------------------------------
void __fastcall TForm3::Button3Click(TObject *Sender)
{
  // Update the query component. Please make sure that
  // you have entered a valid Query to Memo1 component.
  Query1->Active = FALSE;
  Query1->SQL->Assign(Memo1->Lines);
  Query1->Active = TRUE;

  // Re-activate the report
  ActivateComponent();
}
//---------------------------------------------------------------------------

void __fastcall TForm3::Button2Click(TObject *Sender)
{
  CrystalDesign1->NextPrintWindowMagnification();  
}
//---------------------------------------------------------------------------

